#include "stdlib.h"
#include "config.h"
#include "drawbot.h" 
#include "led.h"
#include "line.h" 
#include "make.h" 
#include "rtos.h"
#include "string.h"
#include "config.h"
#include "AT91SAM7X256.h"
#include "types.h"
#include "timer.h"
#include "timer_internal.h"


unsigned short xSensor = HIGH; 
unsigned short ySensor = HIGH; 
unsigned short zTopSensor = HIGH;  
unsigned short zBottomSensor = HIGH; 
unsigned short zMidSensor = HIGH;

void MainTask( ); 
void EdgePoll( void ); 
void EnableControllers(void);
void DisableControllers(void); 
void ResetPen(void);
void NetworkAcceptPoints(void);

/**
 *
 **/
 
void Make(void )
{
    Network_SetAddress( 192, 168, 0, 200 );
    Network_SetMask( 255, 255, 255, 0 );
    Network_SetValid( 1 );
    Network_SetActive(1);
    
    EdgePoll();
    EnableControllers();
    ResetPen();
    DisableControllers();
    NetworkAcceptPoints();
}//END Make


/**
 *
 */
void NetworkAcceptPoints(void ){ 
	int buffsize = 256;
	void *sock = ServerSocket(2112); 
	char buffer[buffsize];
        void *tmpsock = NULL; 
        int len = 0;
        bzero(buffer,buffsize);  	
	while(1) { 	
 	
        tmpsock = ServerSocketAccept( sock );
        EnableControllers(); 
        len = SocketRead(tmpsock,buffer,buffsize); 	
         while( len > 0  ) { 
            	
	 if( ParseInput( buffer, len ) == 0)
               break;
           
         bzero( buffer, buffsize );
         len = SocketRead(tmpsock,buffer,buffsize); 	
        }
 		
	SocketClose(tmpsock);
        ResetPen(); 	
        DisableControllers(); 
       }

}


/**
  *
  **/
void DisableControllers() { 

  DigitalOut_SetValue(ENABLE_CONTROLLERS, 1 );

}//END DisableController 

/*
 *
 */ 
void ResetPen(void) { 

  ySensor = DigitalIn_GetValue( Y_SENSOR_EDGE_INPUT ); 
  xSensor = DigitalIn_GetValue( X_SENSOR_EDGE_INPUT ); 
  
  DigitalOut_SetValue( X_AXIS_DIR_OUTPUT, X_BACK );
  DigitalOut_SetValue( Y_AXIS_DIR_OUTPUT, Y_BACK );
 
  MovePen(UP); 

  

  while( ySensor == HIGH ) { 
    ySensor = DigitalIn_GetValue( Y_SENSOR_EDGE_INPUT ); 
    DigitalOut_SetValue( Y_AXIS_STEP_OUTPUT, LOW );
    DigitalOut_SetValue( Y_AXIS_STEP_OUTPUT, HIGH );
    vTaskDelay( MOVE_DELAY );
  } 

  while( xSensor == HIGH ) { 
    xSensor = DigitalIn_GetValue( X_SENSOR_EDGE_INPUT ); 
    DigitalOut_SetValue( X_AXIS_STEP_OUTPUT, LOW ); 
    DigitalOut_SetValue( X_AXIS_STEP_OUTPUT, HIGH  );
    vTaskDelay( MOVE_DELAY );
  }

 MovePen(DOWN); 
}//END ResetPen



/**
 *
 */
void EdgePoll(void ) { 
 
 xSensor =  DigitalIn_GetValue( X_SENSOR_EDGE_INPUT ); 
 ySensor =  DigitalIn_GetValue( Y_SENSOR_EDGE_INPUT ); 
 zTopSensor =  DigitalIn_GetValue( Z_SENSOR_TOP_INPUT ); 
 zBottomSensor = DigitalIn_GetValue( Z_SENSOR_BOTTOM_INPUT ); 
 zMidSensor = DigitalIn_GetValue( Z_SENSOR_MID_INPUT ); 

}//END EdgePoll


/**
 *
 **/ 
void EnableControllers(void) { 
	DigitalOut_SetValue(ENABLE_CONTROLLERS, 0 ); 
}//END EnableController 	
